<script lang="ts">
import {
  and,
  type ControlElement,
  formatIs,
  isStringControl,
  type JsonFormsRendererRegistryEntry,
  rankWith,
} from "@jsonforms/core";
import { rendererProps, type RendererProps, useJsonFormsControl } from "@jsonforms/vue";
import { ControlWrapper, DisabledIconFocus, useVuetifyControl } from "@jsonforms/vue-vuetify";
import debounce from "lodash/debounce";
import { defineComponent, ref } from "vue";
import { VHover } from "vuetify/components";

const controlRenderer = defineComponent({
  name: "RorControlRenderer",
  components: {
    ControlWrapper,
    VHover,
  },
  directives: {
    DisabledIconFocus,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    const control = useVuetifyControl(
      useJsonFormsControl(props),
      value => value || undefined,
      300,
    );

    const search = ref("");
    const listData = ref([]);
    const loading = ref(false);

    const handleDataUpdate = (organization: any) => {
      const regex = /^(\d+)\./;
      const match = control.control.value.path.match(regex);
      const pos = match ? Number.parseInt(match[1], 10) : null;
      const pathName = pos !== null ? `${pos}.organization.name` : "organization.name";
      const pathUrl = pos !== null ? `${pos}.organization.url` : "organization.url";
      const pathCountry = pos !== null ? `${pos}.organization.address.addressCountry` : "organization.address.addressCountry";
      const pathCity = pos !== null ? `${pos}.organization.address.addressLocality` : "organization.address.addressLocality";
      const pathId = pos !== null ? `${pos}.organization.identifier` : "organization.identifier";

      // Check if organization data is valid before updating fields
      if (organization.name && organization.id) {
        // Update fields only if name and id are valid
        control.handleChange(pathName, organization.name);
        control.handleChange(pathId, organization.id);
        control.handleChange(pathUrl, organization.url);
        control.handleChange(pathCountry, organization.country);
        control.handleChange(pathCity, organization.city);
      } else {
        // Clear fields if name or id is invalid
        control.handleChange(pathName, "");
        control.handleChange(pathId, "");
        control.handleChange(pathUrl, "");
        control.handleChange(pathCountry, "");
        control.handleChange(pathCity, "");
      }
    };

    const fetchSuggestions = debounce(async (query: string) => {
      if (!query) return;

      loading.value = true;
      const apiUrl = `https://api.ror.org/organizations?query=${encodeURIComponent(query)}`;
      try {
        const response = await fetch(apiUrl);
        if (!response.ok) throw new Error("Error fetching ROR suggestions");

        const data = await response.json();
        listData.value = data.items.map((item: any) => ({
          name: item.name,
          id: item.id,
          url: item.links?.[0],
          country: item.country.country_name,
          city: item.addresses?.[0]?.city,
        }));
      } catch (error) {
        console.error("Error fetching ROR suggestions:", error);
        listData.value = [];
      } finally {
        control.handleChange(control.control.value.path, query);
        loading.value = false;
      }
    }, 300);

    const selectSuggestion = (value: any) => {
      const selectedOrganization = listData.value.find(org => org.name === value);
      if (selectedOrganization) {
        handleDataUpdate(selectedOrganization);
      }
    };

    return { ...control, search, listData, loading, fetchSuggestions, selectSuggestion };
  },
});

export default controlRenderer;

export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(100, and(isStringControl, formatIs("organization-name"))),
};
</script>

<template>
  <ControlWrapper
    v-bind="controlWrapper"
    :styles="styles"
    :is-focused="isFocused"
    :applied-options="appliedOptions"
  >
    <VHover v-slot="{ isHovering }">
      <v-autocomplete
        v-model:search-input="search"
        :items="listData.map(item => item.name)"
        item-text="name"
        :loading="loading"
        :disabled="!control.enabled"
        :placeholder="appliedOptions.placeholder"
        :label="computedLabel"
        :hint="control.description"
        v-bind="vuetifyProps('v-autocomplete')"
        :persistent-hint="persistentHint()"
        :required="control.required"
        :error-messages="control.errors"
        :clearable="isHovering"
        :model-value="control.data"
        @update:model-value="selectSuggestion"
        @update:search="fetchSuggestions"
        @focus="handleFocus"
        @blur="handleBlur"
      >
        <template v-slot:prepend-inner>
          <v-icon v-if="loading">
            mdi-loading
          </v-icon>
        </template>
      </v-autocomplete>
    </VHover>
  </ControlWrapper>
</template>
